// SPDX-License-Identifier: MIT

pragma solidity 0.6.12;

interface IMetamorphicContractFactory {
    function findMetamorphicContractAddress(bytes32 salt)
        external
        view
        returns (address metamorphicContractAddress);

    function deployMetamorphicContractFromExistingImplementation(
        bytes32 salt,
        address implementationContract,
        bytes calldata metamorphicContractInitializationCalldata
    ) external payable returns (address metamorphicContractAddress);
}
